import com.alibaba.fastjson.JSON;
import com.gic.cloud.data.hook.api.dto.DownloadTask;
import com.gic.cloud.data.hook.api.entity.FlatQueryTaskCondition;
import com.gic.cloud.data.hook.service.impl.DownloadTaskServiceImpl;
import com.gic.cloud.data.hook.service.impl.FlatQueryResultServiceImpl;
import com.gic.redis.data.util.RedisUtil;
import org.junit.runner.RunWith;
import org.redisson.api.RedissonClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath*:applicationContext-conf.xml"})
public class Test {

    @Autowired
    private FlatQueryResultServiceImpl flatQueryResultService;

    @Autowired
    private DownloadTaskServiceImpl downloadTaskService;

    @org.junit.Test
    public void test(){
        DownloadTask downloadTask = downloadTaskService.getDownloadTaskById("1680844420436");

        flatQueryResultService.takeFileNew(downloadTask);
        try {
            Thread.sleep(10000000000L);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    @org.junit.Test
    public void test3(){
        ClassPathXmlApplicationContext context = new ClassPathXmlApplicationContext("redis-init.xml");
        RedissonClient redisClient = RedisUtil.getRedisClient();
        System.out.println(redisClient);
    }

    @org.junit.Test
    public void test2(){
        String json="{\"allFields\":[\"card_name\",\"sub_title\",\"status\",\"coup_put_time\",\"used_time\",\"receive_card_num\",\"receive_main_store_code\"],\"amount\":4250000,\"authStoreIdList\":[],\"buildPermitted\":\"1\",\"conditions\":[{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"卡券名称\",\"fieldName\":\"card_name\",\"fieldType\":\"text\",\"filterTunnel\":\"\",\"mainFilter\":\"\"},{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"卡券副标题\",\"fieldName\":\"sub_title\",\"fieldType\":\"text\",\"filterTunnel\":\"\",\"mainFilter\":\"\"},{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"优惠券状态\",\"fieldName\":\"status\",\"fieldType\":\"text\",\"filterTunnel\":\"\",\"mainFilter\":\"已领取\"},{\"enableEncrypt\":false,\"extendFilter\":\"2023-01-13 23:59:59\",\"fieldMark\":\"卡券投放时间\",\"fieldName\":\"coup_put_time\",\"fieldType\":\"date\",\"filterTunnel\":\"\",\"mainFilter\":\"2023-01-12 00:00:00\"},{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"卡券使用时间\",\"fieldName\":\"used_time\",\"fieldType\":\"date\",\"filterTunnel\":\"\",\"mainFilter\":\"\"},{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"卡券领取人会员卡号\",\"fieldName\":\"receive_card_num\",\"fieldType\":\"text\",\"filterTunnel\":\"\",\"mainFilter\":\"\"},{\"enableEncrypt\":false,\"extendFilter\":\"\",\"fieldMark\":\"领取人服务门店code\",\"fieldName\":\"receive_main_store_code\",\"fieldType\":\"text\",\"filterTunnel\":\"\",\"mainFilter\":\"\"}],\"decryptFilters\":[],\"enterpriseIds\":[\"ff80808180b3c54a0180bc3df3bb4bca\"],\"execDistinct\":false,\"orderDir\":\"\",\"orderField\":\"\",\"queryDataType\":0,\"tableId\":\"extract_coup_card_detail\",\"taskId\":\"1673977015068\"}";
        FlatQueryTaskCondition condition = JSON.parseObject(json, FlatQueryTaskCondition.class);
        String fullQuery = flatQueryResultService.buildFlatQuerySQL(
                false, // 下载用途
                condition.getTableId(),
                condition.getEnterpriseIds(),
                condition.getConditions(),
                condition.getOrderField(),
                condition.getOrderDir(),
                condition.getExecDistinct(),
                0,
                condition.getAuthStoreIdList());

        System.out.println(fullQuery);
    }
}
